# coding: utf-8

"""
    User Service API

    Solomon AI User Service API - Manages user profiles and authentication

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@solomon-ai.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from solomonai_backend_client_sdk.models.workspace import Workspace
from typing import Optional, Set
from typing_extensions import Self

class ListWorkspaceResponse(BaseModel):
    """
    ListWorkspaceResponse represents the response containing a list of workspaces. This message returns all workspaces that match the request criteria and are accessible to the requesting user within their organizational context.
    """ # noqa: E501
    workspace: Optional[List[Workspace]] = None
    total_count: Optional[StrictInt] = Field(default=None, alias="totalCount")
    next_page_token: Optional[StrictStr] = Field(default=None, alias="nextPageToken")
    last_sync_time: Optional[StrictStr] = Field(default=None, alias="lastSyncTime")
    workspace_stats: Optional[Dict[str, StrictStr]] = Field(default=None, description="workspace_stats provides aggregate statistics about the returned workspaces Such as total storage used, number of files, etc.", alias="workspaceStats")
    __properties: ClassVar[List[str]] = ["workspace", "totalCount", "nextPageToken", "lastSyncTime", "workspaceStats"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListWorkspaceResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in workspace (list)
        _items = []
        if self.workspace:
            for _item in self.workspace:
                if _item:
                    _items.append(_item.to_dict())
            _dict['workspace'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListWorkspaceResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "workspace": [Workspace.from_dict(_item) for _item in obj["workspace"]] if obj.get("workspace") is not None else None,
            "totalCount": obj.get("totalCount"),
            "nextPageToken": obj.get("nextPageToken"),
            "lastSyncTime": obj.get("lastSyncTime"),
            "workspaceStats": obj.get("workspaceStats")
        })
        return _obj


