# coding: utf-8

"""
    User Service API

    Solomon AI User Service API - Manages user profiles and authentication

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@solomon-ai.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from solomonai_backend_client_sdk.models.audit_action import AuditAction
from typing import Optional, Set
from typing_extensions import Self

class RoleAuditEvents(BaseModel):
    """
    RoleAuditEvents defines the audit record for any changes made to a role.
    """ # noqa: E501
    id: Optional[StrictStr] = None
    action: Optional[AuditAction] = AuditAction.UNSPECIFIED
    performed_by: Optional[StrictStr] = Field(default=None, alias="performedBy")
    timestamp: Optional[datetime] = None
    affected_fields: Optional[List[StrictStr]] = Field(default=None, alias="affectedFields")
    previous_values: Optional[List[StrictStr]] = Field(default=None, alias="previousValues")
    client_ip: Optional[StrictStr] = Field(default=None, alias="clientIp")
    user_agent: Optional[StrictStr] = Field(default=None, alias="userAgent")
    context: Optional[StrictStr] = None
    deleted_at: Optional[datetime] = Field(default=None, alias="deletedAt")
    __properties: ClassVar[List[str]] = ["id", "action", "performedBy", "timestamp", "affectedFields", "previousValues", "clientIp", "userAgent", "context", "deletedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RoleAuditEvents from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RoleAuditEvents from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "action": obj.get("action") if obj.get("action") is not None else AuditAction.UNSPECIFIED,
            "performedBy": obj.get("performedBy"),
            "timestamp": obj.get("timestamp"),
            "affectedFields": obj.get("affectedFields"),
            "previousValues": obj.get("previousValues"),
            "clientIp": obj.get("clientIp"),
            "userAgent": obj.get("userAgent"),
            "context": obj.get("context"),
            "deletedAt": obj.get("deletedAt")
        })
        return _obj


