# coding: utf-8

"""
    User Service API

    Solomon AI User Service API - Manages user profiles and authentication

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@solomon-ai.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class SortField(str, Enum):
    """
    SortField defines the available fields for sorting file and folder listings. Used to control the order of items in directory listings and search results.  Values: - UNSPECIFIED: Default value, no sort specified - NAME: Sort alphabetically by name - CREATED_AT: Sort by creation timestamp - UPDATED_AT: Sort by last modification time - SIZE: Sort by file size  Usage example: ```go listFiles := &ListFilesRequest{   SortBy: SortField_SORT_FIELD_UPDATED_AT,   SortDescending: true } ```  Notes: - All sort operations support both ascending and descending order - UNSPECIFIED typically falls back to NAME sorting - SIZE sorting is only meaningful for files (folders show as 0 bytes)   - SORT_FIELD_UNSPECIFIED: Default value, no sort specified  - SORT_FIELD_NAME: Sort by item name (alphabetical)  - SORT_FIELD_CREATED_AT: Sort by creation timestamp  - SORT_FIELD_UPDATED_AT: Sort by last modification time  - SORT_FIELD_SIZE: Sort by file size (bytes)
    """

    """
    allowed enum values
    """
    SORT_FIELD_UNSPECIFIED = 'SORT_FIELD_UNSPECIFIED'
    SORT_FIELD_NAME = 'SORT_FIELD_NAME'
    SORT_FIELD_CREATED_AT = 'SORT_FIELD_CREATED_AT'
    SORT_FIELD_UPDATED_AT = 'SORT_FIELD_UPDATED_AT'
    SORT_FIELD_SIZE = 'SORT_FIELD_SIZE'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of SortField from a JSON string"""
        return cls(json.loads(json_str))


